// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'AppBar.pas' rev: 3.00

#ifndef AppBarHPP
#define AppBarHPP
#include <Forms.hpp>
#include <Classes.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Appbar
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS TAppBarFormHookComponent;
class PASCALIMPLEMENTATION TAppBarFormHookComponent : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	bool Hooked;
	bool FTopmost;
	Forms::TForm* FParentForm;
	int FHHandle;
	int FParentHandle;
	void *FOldWndProc;
	void *FNewWndProc;
	void __fastcall HookWndProc(Messages::TMessage &Message);
	int __fastcall GetWindowStyle(void);
	void __fastcall SetWindowStyle(int Value);
	int __fastcall GetWindowExStyle(void);
	void __fastcall SetWindowExStyle(int Value);
	
protected:
	virtual void __fastcall MessageBefore(Messages::TMessage &Message, bool &Handled);
	virtual void __fastcall MessageAfter(Messages::TMessage &Message);
	virtual void __fastcall FormRecreate(void);
	virtual void __fastcall WndProc(Messages::TMessage &Message);
	virtual int __fastcall GetParentHandle(void);
	bool __fastcall GetTopmost(void);
	void __fastcall SetTopmost(bool Value);
	
public:
	__fastcall virtual TAppBarFormHookComponent(Classes::TComponent* aOwner);
	__fastcall virtual ~TAppBarFormHookComponent(void);
	void __fastcall RefreshNCArea(void);
	__property int HHandle = {read=FHHandle, nodefault};
	__property Forms::TForm* ParentForm = {read=FParentForm, write=FParentForm};
	__property int ParentHandle = {read=FParentHandle, nodefault};
	__property void * OldWndProc = {read=FOldWndProc};
	__property int WindowStyle = {read=GetWindowStyle, write=SetWindowStyle, nodefault};
	__property int WindowExStyle = {read=GetWindowExStyle, write=SetWindowExStyle, nodefault};
	__property bool Topmost = {read=GetTopmost, write=SetTopmost, nodefault};
	__property bool TopmostDesign = {read=FTopmost, nodefault};
};

class DELPHICLASS TAppBarAppHookComponent;
class PASCALIMPLEMENTATION TAppBarAppHookComponent : public Appbar::TAppBarFormHookComponent 
{
	typedef Appbar::TAppBarFormHookComponent inherited;
	
private:
	bool AppHooked;
	void *OldAppWndProc;
	void *NewAppWndProc;
	void __fastcall HookAppMessages(void);
	void __fastcall UnhookAppMessages(void);
	void __fastcall HookAppProc(Messages::TMessage &Message);
	
protected:
	virtual void __fastcall AppMessageBefore(Messages::TMessage &Message, bool &Handled);
	virtual void __fastcall AppMessageAfter(Messages::TMessage &Message);
	
public:
	__fastcall virtual TAppBarAppHookComponent(Classes::TComponent* aOwner);
	__fastcall virtual ~TAppBarAppHookComponent(void);
};

class DELPHICLASS TAppBarPersistent;
class DELPHICLASS TAppBar;
enum TAppBarPlacement { bpLeft, bpTop, bpRight, bpBottom, bpFloat };

typedef Set<TAppBarPlacement, bpLeft, bpFloat>  TAppBarEdges;

class DELPHICLASS TAppBarDocking;
class PASCALIMPLEMENTATION TAppBarPersistent : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	bool FEnabled;
	TAppBar* FOwner;
	
public:
	__fastcall virtual TAppBarPersistent(TAppBar* aAppBar);
	__property TAppBar* Owner = {read=FOwner};
	
__published:
	__property bool Enabled = {read=FEnabled, write=FEnabled, default=1};
public:
	/* TPersistent.Destroy */ __fastcall virtual ~TAppBarPersistent(void) { }
	
};

class PASCALIMPLEMENTATION TAppBarDocking : public Appbar::TAppBarPersistent 
{
	typedef Appbar::TAppBarPersistent inherited;
	
private:
	Word FHeight;
	Word FWidth;
	Word FMaxHeight;
	Word FMaxWidth;
	Word FMinHeight;
	Word FMinWidth;
	void __fastcall SetHeight(Word Value);
	void __fastcall SetWidth(Word Value);
	
public:
	__fastcall virtual TAppBarDocking(TAppBar* aAppBar);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property Word Height = {read=FHeight, write=SetHeight, default=32};
	__property Word Width = {read=FWidth, write=SetWidth, default=32};
	__property Word MaxHeight = {read=FMaxHeight, write=FMaxHeight, default=300};
	__property Word MaxWidth = {read=FMaxWidth, write=FMaxWidth, default=400};
	__property Word MinHeight = {read=FMinHeight, write=FMinHeight, default=0};
	__property Word MinWidth = {read=FMinWidth, write=FMinWidth, default=0};
public:
	/* TPersistent.Destroy */ __fastcall virtual ~TAppBarDocking(void) { }
	
};

class DELPHICLASS TAppBarFloatRestrictions;
class PASCALIMPLEMENTATION TAppBarFloatRestrictions : public Appbar::TAppBarPersistent 
{
	typedef Appbar::TAppBarPersistent inherited;
	
private:
	Word FMaxWidth;
	Word FMaxHeight;
	Word FMinWidth;
	Word FMinHeight;
	void __fastcall SetMaxWidth(Word Value);
	void __fastcall SetMaxHeight(Word Value);
	void __fastcall SetMinWidth(Word Value);
	void __fastcall SetMinHeight(Word Value);
	void __fastcall UpdateFloatRestrictions(void);
	
public:
	__fastcall virtual TAppBarFloatRestrictions(TAppBar* aAppBar);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property Enabled ;
	__property Word MaxWidth = {read=FMaxWidth, write=SetMaxWidth, default=0};
	__property Word MaxHeight = {read=FMaxHeight, write=SetMaxHeight, default=0};
	__property Word MinWidth = {read=FMinWidth, write=SetMinWidth, default=0};
	__property Word MinHeight = {read=FMinHeight, write=SetMinHeight, default=0};
public:
	/* TPersistent.Destroy */ __fastcall virtual ~TAppBarFloatRestrictions(void) { }
	
};

class DELPHICLASS TAppBarRegistrySaver;
enum TAppBarRegLocation { rlCurrentUser, rlLocalMachine };

enum TAppBarRestoreProperty { rpAllowedEdges, rpFormSize, rpDocking, rpFloatRestrictions, rpSizing, 
	rpSliding };

typedef Set<TAppBarRestoreProperty, rpAllowedEdges, rpSliding>  TAppBarRestoreProperties;

enum AppBar__8 { saveOnClose, saveOnMoveResize };

typedef Set<AppBar__8, saveOnClose, saveOnMoveResize>  TAppBarRegOptions;

enum TAppBarStorageType { useRegistry, useIniFile };

class PASCALIMPLEMENTATION TAppBarRegistrySaver : public Appbar::TAppBarPersistent 
{
	typedef Appbar::TAppBarPersistent inherited;
	
private:
	System::AnsiString FIniFileName;
	System::AnsiString FIniSection;
	TAppBarRegLocation FRegLocation;
	System::AnsiString FRegKey;
	TAppBarRestoreProperties FRestoreProperties;
	TAppBarRegOptions FOptions;
	TAppBarStorageType FStorage;
	void __fastcall SetRegLocation(TAppBarRegLocation Value);
	void __fastcall SetRegKey(System::AnsiString Value);
	
public:
	__fastcall virtual TAppBarRegistrySaver(TAppBar* aAppBar);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall Load(void);
	void __fastcall Save(void);
	
__published:
	__property Enabled ;
	__property System::AnsiString IniFileName = {read=FIniFileName, write=FIniFileName};
	__property System::AnsiString IniSection = {read=FIniSection, write=FIniSection};
	__property TAppBarRegLocation RegLocation = {read=FRegLocation, write=SetRegLocation, default=0};
	__property System::AnsiString RegKey = {read=FRegKey, write=SetRegKey};
	__property TAppBarRestoreProperties RestoreProperties = {read=FRestoreProperties, write=FRestoreProperties
		, default=54};
	__property TAppBarRegOptions Options = {read=FOptions, write=FOptions, default=1};
	__property TAppBarStorageType Storage = {read=FStorage, write=FStorage, default=0};
public:
	/* TPersistent.Destroy */ __fastcall virtual ~TAppBarRegistrySaver(void) { }
	
};

class DELPHICLASS TAppBarSizing;
class PASCALIMPLEMENTATION TAppBarSizing : public Appbar::TAppBarPersistent 
{
	typedef Appbar::TAppBarPersistent inherited;
	
private:
	Word FHorizontalIncrement;
	Word FVerticalIncrement;
	
public:
	__fastcall virtual TAppBarSizing(TAppBar* aAppBar);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property Word HorizontalIncrement = {read=FHorizontalIncrement, write=FHorizontalIncrement, default=1
		};
	__property Word VerticalIncrement = {read=FVerticalIncrement, write=FVerticalIncrement, default=1};
		
public:
	/* TPersistent.Destroy */ __fastcall virtual ~TAppBarSizing(void) { }
	
};

class DELPHICLASS TAppBarSliding;
class PASCALIMPLEMENTATION TAppBarSliding : public Appbar::TAppBarPersistent 
{
	typedef Appbar::TAppBarPersistent inherited;
	
private:
	Word FSlideTime;
	
public:
	__fastcall virtual TAppBarSliding(TAppBar* aAppBar);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property Word SlideTime = {read=FSlideTime, write=FSlideTime, default=200};
public:
	/* TPersistent.Destroy */ __fastcall virtual ~TAppBarSliding(void) { }
	
};

enum TAppBarShowBehavior { sbOnFloat, sbShowAlways, sbHideAlways };

typedef void __fastcall (__closure *TAppBarDockedEvent)(System::TObject* Sender, TAppBarPlacement NewPlacement
	);

typedef void __fastcall (__closure *TAppBarDockingEvent)(System::TObject* Sender, TAppBarPlacement &
	NewPlacement);

typedef void __fastcall (__closure *TAppBarHidingEvent)(System::TObject* Sender, bool &AllowOperation
	);

typedef void __fastcall (__closure *TAppBarFullScreenAppEvent)(System::TObject* Sender, bool Open);

typedef void __fastcall (__closure *TAppBarWindowArrangeEvent)(System::TObject* Sender, bool Beginning
	);

class PASCALIMPLEMENTATION TAppBar : public Appbar::TAppBarAppHookComponent 
{
	typedef Appbar::TAppBarAppHookComponent inherited;
	
private:
	TAppBarEdges FAllowedEdges;
	bool FAutoHide;
	TAppBarDocking* FDocking;
	bool FDontSlideOnTaskBarWhenAutoHide;
	TAppBarFloatRestrictions* FFloatRestrictions;
	TAppBarPlacement FLastDockingPlace;
	TAppBarPlacement FPlacement;
	TAppBarRegistrySaver* FRegistrySaver;
	TAppBarSizing* FSizing;
	TAppBarSliding* FSliding;
	TAppBarShowBehavior FTaskIcon;
	TAppBarShowBehavior FTitleBar;
	Classes::TNotifyEvent FOnActivate;
	Classes::TNotifyEvent FOnDeactivate;
	Classes::TNotifyEvent FOnClick;
	Classes::TNotifyEvent FOnDblClick;
	TAppBarDockedEvent FOnDocked;
	TAppBarDockingEvent FOnDocking;
	TAppBarDockedEvent FOnDockMove;
	Classes::TNotifyEvent FOnExitSizeMove;
	TAppBarHidingEvent FOnHiding;
	TAppBarHidingEvent FOnUnhiding;
	TAppBarFullScreenAppEvent FOnFullScreenApp;
	Classes::TNotifyEvent FOnOtherAppBarPosChanged;
	Classes::TNotifyEvent FOnUnableToAutoHide;
	TAppBarWindowArrangeEvent FOnWindowArrange;
	bool FAutoHideVisible;
	bool FRegistered;
	bool FMoved;
	bool FFixPlacement;
	TAppBarPlacement FProposedPlacement;
	Windows::TRect FFloatRect;
	Windows::TRect FMovingRect;
	bool FFullScreenAppOpen;
	void __fastcall SetAutoHide(bool Value);
	TAppBarPlacement __fastcall GetPlacement(void);
	void __fastcall SetPlacement(TAppBarPlacement Value);
	void __fastcall SetTaskIcon(TAppBarShowBehavior Value);
	void __fastcall SetTitleBar(TAppBarShowBehavior Value);
	int __fastcall ScreenLeft(void);
	int __fastcall ScreenWidth(void);
	int __fastcall ScreenTop(void);
	int __fastcall ScreenHeight(void);
	void __fastcall GetProposedRect(TAppBarPlacement ProposedPlacement, Windows::TRect &rcProposed);
	bool __fastcall AdjustLocationForAutoHide(bool Show, Windows::TRect &rc);
	void __fastcall SlideWindow(Windows::TRect &rcEnd);
	void __fastcall SetWindowRect(const Windows::TRect &Rect);
	Windows::TSmallPoint __fastcall GetMessagePosition(void);
	void __fastcall ChangeWindowStyle(bool Moving, const TAppBarPlacement ProposedPlacement);
	bool __fastcall CanHideUnhide(void);
	void __fastcall DoShowHiddenAppBar(bool Show);
	void __fastcall RegisterAppBar(void);
	void __fastcall UnregisterAppBar(void);
	void __fastcall UpdateTimer(void);
	void __fastcall UpdateTaskIcon(void);
	int __fastcall AppBarMessage(int abMessage, const TAppBarPlacement abPlacement, int Param, bool bRect
		, Windows::TRect &RRect);
	void __fastcall AppBarMessage1(int abMessage);
	int __fastcall AppBarMessage2(int abMessage, const TAppBarPlacement abPlacement);
	int __fastcall AppBarMessage3(int abMessage, const TAppBarPlacement abPlacement, int Param);
	void __fastcall AppBarMessage4(int abMessage, const TAppBarPlacement abPlacement, Windows::TRect &RRect
		);
	void __fastcall AppBarMessage5Undock(void);
	
protected:
	virtual void __fastcall WndProc(Messages::TMessage &Message);
	virtual void __fastcall AppMessageBefore(Messages::TMessage &Message, bool &Handled);
	virtual void __fastcall MessageBefore(Messages::TMessage &Message, bool &Handled);
	virtual void __fastcall MessageAfter(Messages::TMessage &Message);
	virtual void __fastcall Loaded(void);
	
public:
	__fastcall virtual TAppBar(Classes::TComponent* aOwner);
	__fastcall virtual ~TAppBar(void);
	virtual void __fastcall UpdateBar(void);
	void __fastcall ShowHiddenAppBar(const bool Show);
	bool __fastcall IsMouseOverAppBar(void);
	__property bool AutoHideVisible = {read=FAutoHideVisible, nodefault};
	
__published:
	__property TAppBarEdges AllowedEdges = {read=FAllowedEdges, write=FAllowedEdges, default=31};
	__property bool AlwaysOnTop = {read=GetTopmost, write=SetTopmost, default=1};
	__property bool AutoHide = {read=FAutoHide, write=SetAutoHide, default=0};
	__property TAppBarDocking* Docking = {read=FDocking, write=FDocking};
	__property bool DontSlideOnTaskBarWhenAutoHide = {read=FDontSlideOnTaskBarWhenAutoHide, write=FDontSlideOnTaskBarWhenAutoHide
		, default=0};
	__property TAppBarFloatRestrictions* FloatRestrictions = {read=FFloatRestrictions, write=FFloatRestrictions
		};
	__property TAppBarPlacement LastDockingPlace = {read=FLastDockingPlace, write=FLastDockingPlace, default=1
		};
	__property TAppBarPlacement Placement = {read=GetPlacement, write=SetPlacement, default=4};
	__property TAppBarRegistrySaver* RegistrySaver = {read=FRegistrySaver, write=FRegistrySaver};
	__property TAppBarSizing* Sizing = {read=FSizing, write=FSizing};
	__property TAppBarSliding* Sliding = {read=FSliding, write=FSliding};
	__property TAppBarShowBehavior TaskIcon = {read=FTaskIcon, write=SetTaskIcon, default=0};
	__property TAppBarShowBehavior TitleBar = {read=FTitleBar, write=SetTitleBar, default=0};
	__property Classes::TNotifyEvent OnActivate = {read=FOnActivate, write=FOnActivate};
	__property Classes::TNotifyEvent OnClick = {read=FOnClick, write=FOnClick};
	__property Classes::TNotifyEvent OnDblClick = {read=FOnDblClick, write=FOnDblClick};
	__property Classes::TNotifyEvent OnDeactivate = {read=FOnDeactivate, write=FOnDeactivate};
	__property TAppBarDockedEvent OnDocked = {read=FOnDocked, write=FOnDocked};
	__property TAppBarDockingEvent OnDocking = {read=FOnDocking, write=FOnDocking};
	__property TAppBarDockedEvent OnDockMove = {read=FOnDockMove, write=FOnDockMove};
	__property Classes::TNotifyEvent OnExitSizeMove = {read=FOnExitSizeMove, write=FOnExitSizeMove};
	__property TAppBarFullScreenAppEvent OnFullScreenApp = {read=FOnFullScreenApp, write=FOnFullScreenApp
		};
	__property Classes::TNotifyEvent OnOtherAppBarPosChanged = {read=FOnOtherAppBarPosChanged, write=FOnOtherAppBarPosChanged
		};
	__property Classes::TNotifyEvent OnUnableToAutoHide = {read=FOnUnableToAutoHide, write=FOnUnableToAutoHide
		};
	__property TAppBarWindowArrangeEvent OnWindowArrange = {read=FOnWindowArrange, write=FOnWindowArrange
		};
	__property TAppBarHidingEvent OnHiding = {read=FOnHiding, write=FOnHiding};
	__property TAppBarHidingEvent OnUnhiding = {read=FOnUnhiding, write=FOnUnhiding};
};


//-- var, const, procedure ---------------------------------------------------
#define UM_RECREATENOTIFY (Word)(1325)
#define WM_FORMCAPTIONCHANGED (Word)(14937)
#define WM_SYSTEMMENUCHANGED (Word)(14944)
#define WM_WHATSTHIS (Word)(14945)
#define WM_TOPMOSTCHANGEDNOTIFY (Word)(14946)
#define WM_APPBARNOTIFY (Word)(14947)
#define WM_TRAYICONNOTIFY (Word)(14948)
#define WM_RECREATENOTIFY (Word)(14949)
#define WM_APPBARSHOWINGCHANGED (Word)(14950)
#define DEFAULT_SLIDE_TIME (Byte)(200)
#define DEFAULT_DOCK_MAXWIDTH (Word)(400)
#define DEFAULT_DOCK_MAXHEIGHT (Word)(300)
#define DEFAULT_DOCK_WIDTH (Byte)(32)
#define DEFAULT_DOCK_HEIGHT (Byte)(32)

}	/* namespace Appbar */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Appbar;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// AppBar
